package factory.shapefact1;
import java.util.*;
//import junit.framework.*;
 
abstract class Shape {
  public abstract void draw();
  public abstract void erase();
}
 
class Circle extends Shape {
  Circle() {} // Package-access constructor
  public void draw() {
    System.out.println("Circle.draw");
  }
  public void erase() {
    System.out.println("Circle.erase");
  }
}
 
class Square extends Shape {
  Square() {} // Package-access constructor
  public void draw() {
    System.out.println("Square.draw");
  }
  public void erase() {
    System.out.println("Square.erase");
  }
}
 
public class ShapeTest1 { // extends TestCase  {
  String shlist[] = { "Circle", "Square",
    "Square", "Circle", "Circle", "Square" };
  List shapes = new ArrayList();

  public void test() {
    Iterator it = Arrays.asList(shlist).iterator();
    while(it.hasNext()) {
        String type=(String)it.next();
        if(type.equals("Circle")) shapes.add(new Circle());
        if(type.equals("Square")) shapes.add(new Square());
      }
    it = shapes.iterator();
    while(it.hasNext()) {
      Shape s = (Shape)it.next();
      s.draw();
      s.erase();
    }
  }
//public static void main(String args[]) {
//  junit.textui.TestRunner.run(ShapeTest1.class);
//}
} ///:~
