/***************************************************
*                                                  *
* Graph datas interface :                          *
*                                                  *
* Provide basic logic expressions predicates       *
*                                                  *
***************************************************/

% Assert basic relations exists

  uses('','').
  contains('','').
  inherits('','').
  virtual_package('','').
  scope('','').
  node('').

  classtype('','').
  interfacetype('','').
  typename('').
  typename('','').
  id('').
  tuple('','').
  method('').
  method('','','').
  methodname('','').
  methodname('').
  packagename('').
  field('','').
  exprname('').
  exprname('','').
  none.
  some('').
  root.
  arraytype('').
  arrayvardecid('','').
  dim.

  inherits('','').
  contains('','').
  uses('','').

% Basic primitives

% Node1 uses Node2
  u(Node1,Node2) :- uses(Node1,Node2).

% Container contains Contained
  c(Node1,Node2) :- contains(Node1,Node2).

% Class inherits from Base
  s(Node1,Node2) :- inherits(Node1,Node2).
